#!/usr/bin/perl -w

##############################################################################
#
#	dbswitch.pl	-	This program will copy the contents of one db 
#				backend to another.
#				Call it with dbswitch.pl olddriver newdriver
#
#	Author		-	Steve Kordik <countzero@cyberdeck.org>
#
#
##############################################################################

BEGIN {
	$libpath = $0;
	$libpath =~ s!/[^/]+$!!;
	$libpath =~ s!/bin$!/lib/cscmail!;
	if (! -e $libpath) { die "Can't find required files in $libpath"; };
}

use lib "$libpath";
use lib "$libpath/modules/lib/perl5/site_perl/5.005";
use DBI;

require 'csclib.pl';
($olddriver, $newdriver) = @ARGV;
if (not defined $olddriver || not defined $newdriver) {
 print ("Usage: dbswitch.pl olddriver newdriver\n");
 exit;
}

$prefs{'DatabaseDriver'} = $olddriver;

$olddbh=&open_db_conn;

$prefs{'DatabaseDriver'} = $newdriver;

$conn=&open_db_conn;

&create_database;
$sql = "select * from messages";
$query=$olddbh->prepare($sql);
$query->execute();
$sql = "insert into messages (id, msgid, boxid, accountid,
          date, sentto, sentfrom, subject, contenttype,
          contentxferencode, mimeversion, precedence,
          approvedby, inreplyto, replyto, listsub,
          listunsub, status, xorigip, cc, sender,
          returnpath, priority, xmailer, xsender,
          localdate, newmsg, replyf, friendly, rreceiptto, score)
	values
	(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
$query2=$conn->prepare($sql);
while (@row=$query->fetchrow_array()) {
 $query2->execute(@row);
}
$sql = "select * from accounts";
$query=$olddbh->prepare($sql);
$query->execute();
$sql = "insert into accounts (id, uname, friendly, smtp,
          pop, pport, pass, reply, include,
          dm, def,type, dupecheck)
	values
	(?,?,?,?,?,?,?,?,?,?,?,?,?)";
$query2=$conn->prepare($sql);
while (@row=$query->fetchrow_array()) {
 $query2->execute(@row);
}
$sql = "select * from addresses";
$query=$olddbh->prepare($sql);
$query->execute();
$sql = "insert into addresses (id, alias, address, public_key)
	values
	(?,?,?,?)";
$query2=$conn->prepare($sql);
while (@row=$query->fetchrow_array()) {
 $query2->execute(@row);
}
$sql = "select * from boxlist";
$query=$olddbh->prepare($sql);
$query->execute();
$sql = "insert into boxlist (id, name, sibling, parent)
	values
	(?,?,?,?)";
$query2=$conn->prepare($sql);
while (@row=$query->fetchrow_array()) {
	if ($row[0] > 4) {
		$query2->execute(@row);
	}
}
$sql = "select * from filters";
$query=$olddbh->prepare($sql);
$query->execute();
$sql = "insert into filters (id, sorder, type, boxid, regex, addr, name)
	values
	(?,?,?,?,?,?,?)";
$query2=$conn->prepare($sql);
while (@row=$query->fetchrow_array()) {
	$query2->execute(@row);
}
